@page "/cxtransactionviewer"

@using AntDesign
@using System.ComponentModel
@using System.Text;
@using System.Net;
@using FIOWebServer.Models
@using FIOWebServer.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

<h1>CX Transaction Viewer</h1>

<FIOWebServer.Components.LoadingWrapper @bind-ProgressCount="@CurrentProgress" TotalProgress="2">
    <AutoComplete style="width:10%" @bind-Value="@SelectedMaterial" Options="@MaterialOptions" Placeholder="Ticker"/>
    <AutoComplete style="width:10%" @bind-Value="@SelectedExchange" Options="@ExchangeOptions" Placeholder="Exchange"/>
    <div>
        <AntDesign.Row>
            <AntDesign.Col Span="12">
                <em>Hours To Show</em>
                <Slider TValue="double" Min="1" Max="100" @bind-Value="@HoursToShow" TipFormatter="(f) => tipFormatter(f)" />
            </AntDesign.Col>
            <AntDesign.Col Span="4">
                <AntDesign.InputNumber TValue="double" Min="1" Max="100" Style="margin:0 16px;" @bind-Value="@HoursToShow" />
             </AntDesign.Col>
        </AntDesign.Row>
    </div>


    @if (Retrieving)
    {
        <Spin size="large"/>
    }
    else
    {
        <MatThemeProvider Theme="@blackTheme">
            <MatButton Raised="true" Class="mdc-toast-info" Icon="search" OnClick="RetrieveClick">Retrieve</MatButton>
        </MatThemeProvider>
    }

    <Table DataSource="transactions"
        PageSize="100"
        Size=@TableSize.Small
        TItem="CXPCModel"
        Bordered="true">
        <Column @bind-Field="@context.TimeEpochMs" Title="Time" Sortable>
            @context.TimeEpochMs.FromUnixTime().ToLocalTime()
        </Column>
        <Column @bind-Field="@context.Open" Title="Opening Price" Sortable>
            @context.Open.ToString("N2")
        </Column>
        <Column @bind-Field="@context.Close" Title="Closing Price" Sortable>
            @context.Close.ToString("N2")
        </Column>
        <Column @bind-Field="@context.Volume" Title="Volume" Sortable>
            @context.Volume.ToString("N2")
        </Column>
        <Column @bind-Field="@context.Traded" Title="Units Traded" Sortable>
            @context.Traded
        </Column>
    </Table> 
</FIOWebServer.Components.LoadingWrapper>